> For the complete documentation index, see [llms.txt](https://docs.chord.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.chord.co/chord-oms/api-reference/models.md).

# Models

## The product object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"product":{"type":"object","title":"Product","properties":{"available_on":{"format":"date-time","nullable":true,"type":"string"},"classifications":{"type":"array","items":{"$ref":"#/components/schemas/classification"}},"description":{"type":"string","nullable":true},"display_price":{"type":"string"},"has_variants":{"type":"boolean"},"id":{"type":"integer"},"master":{"$ref":"#/components/schemas/variant"},"meta_description":{"type":"string"},"meta_keywords":{"type":"string"},"meta_title":{"type":"string"},"name":{"type":"string"},"option_types":{"type":"array","items":{"$ref":"#/components/schemas/option-type"}},"price":{"type":"string"},"product_properties":{"type":"array","items":{"$ref":"#/components/schemas/product-property"}},"shipping_category_id":{"type":"integer"},"slug":{"type":"string"},"taxon_ids":{"type":"array","items":{"type":"integer"}},"total_on_hand":{"type":"integer"},"variants":{"type":"array","items":{"$ref":"#/components/schemas/variant"}}}},"classification":{"type":"object","title":"Classification","properties":{"position":{"type":"integer"},"taxon":{"$ref":"#/components/schemas/taxon"},"taxon_id":{"type":"integer"}}},"taxon":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"parent_id":{"type":"integer"},"permalink":{"type":"string"},"pretty_name":{"type":"string"},"taxonomy_id":{"type":"integer"},"taxons":{"type":"array","items":{"$ref":"#/components/schemas/taxon"}}},"title":"Taxon"},"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"},"option-type":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"position":{"type":"integer"},"presentation":{"type":"string"}},"title":"Option type"},"product-property":{"type":"object","properties":{"id":{"type":"integer"},"product_id":{"type":"integer"},"property_id":{"type":"integer"},"property_name":{"type":"string"},"value":{"type":"string"}},"title":"Product property"}}}}
```

## The pagination-data object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"pagination-data":{"title":"Pagination data","type":"object","properties":{"count":{"type":"integer"},"current_page":{"type":"integer"},"pages":{"type":"integer"},"per_page":{"type":"integer","description":"This will match the value passed in to the `per_page` query parameter.\n"},"total_count":{"type":"integer"}}}}}}
```

## The image object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"}}}}
```

## The price object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"price":{"type":"object","properties":{"id":{"type":"integer"},"amount":{"type":"string"},"currency":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"variant":{"$ref":"#/components/schemas/variant"}},"title":"Price"},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"}}}}
```

## The variant object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"}}}}
```

## The option-value object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"}}}}
```

## The product-property object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"product-property":{"type":"object","properties":{"id":{"type":"integer"},"product_id":{"type":"integer"},"property_id":{"type":"integer"},"property_name":{"type":"string"},"value":{"type":"string"}},"title":"Product property"}}}}
```

## The option-type object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"option-type":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"position":{"type":"integer"},"presentation":{"type":"string"}},"title":"Option type"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"}}}}
```

## The classification object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"classification":{"type":"object","title":"Classification","properties":{"position":{"type":"integer"},"taxon":{"$ref":"#/components/schemas/taxon"},"taxon_id":{"type":"integer"}}},"taxon":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"parent_id":{"type":"integer"},"permalink":{"type":"string"},"pretty_name":{"type":"string"},"taxonomy_id":{"type":"integer"},"taxons":{"type":"array","items":{"$ref":"#/components/schemas/taxon"}}},"title":"Taxon"}}}}
```

## The taxon object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"taxon":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"parent_id":{"type":"integer"},"permalink":{"type":"string"},"pretty_name":{"type":"string"},"taxonomy_id":{"type":"integer"},"taxons":{"type":"array","items":{"$ref":"#/components/schemas/taxon"}}},"title":"Taxon"}}}}
```

## The OrderMin object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"OrderMin":{"type":"object","title":"Order (Min)","required":["id","number","token","user_id","email","currency","locale","total","display_total","item_total","display_item_total","payment_total","adjustment_total","ship_total","display_ship_total","tax_total","additional_tax_total","display_additional_tax_total","included_tax_total","display_included_tax_total","created_at","updated_at","completed_at"],"properties":{"id":{"type":"integer"},"number":{"type":"string"},"token":{"type":"string","description":"This token can be used as a means of authentication for a subset\nof order operations in a guest checkout scenario. It should be passed\nas header named `X-Spree-Order-Token` on the request.\n"},"user_id":{"type":"integer","nullable":true,"description":"The ID of the user associated with this order. If the order is not in a completed\nstate and the customer is not logged in, this will be `null`.\n"},"email":{"type":"string","format":"email","nullable":true},"currency":{"type":"string","description":"The [ISO 4217 currency code](https://taxsummaries.pwc.com/glossary/currency-codes)\nfor the order.\n"},"locale":{"type":"string","nullable":true},"total":{"type":"string","format":"float","description":"This is the total amount of money that the customer paid/will pay.\nIt is the `item_total` + `shipment_total` + `adjustment_total`.\n"},"display_total":{"type":"string","description":"The formatted `total` with the currency's symbol.\n"},"item_total":{"type":"string","format":"float","description":"The total cost of the items in the cart. This does not include discounts,\nadjustments or shipping.\n"},"display_item_total":{"type":"string","format":"string","description":"The formatted `item_total` with the order's currency symbol.\n"},"payment_total":{"type":"string","format":"float","description":"TBD"},"adjustment_total":{"type":"string","format":"float","description":"The total amount discounted from the order.\n"},"ship_total":{"type":"string","format":"float","description":"The amount of money that the customer paid in shipping costs. For some of\nChord's payment methods, like Stripe, this amount in not known until after\nthe order is completed, as the address input is outside of Chord's systems.\n"},"display_ship_total":{"type":"string","description":"The formatted `ship_total` with the order's currency symbol.\n"},"tax_total":{"type":"string","format":"float","description":"The amount of money the the customer paid in taxes. For some of Chord's\npayment methods, like Stripe, this amount is not known until after the\norder is completed, as the address input is outside of Chord's systems.\n"},"display_tax_total":{"type":"string","description":"The `tax_total` formatted with the order's currency symbol.\n"},"additional_tax_total":{"type":"string","format":"float","description":"If the order requires VAT (Value Added Tax), this is the amount of tax the\ncustomer will pay.\n"},"display_additional_tax_total":{"type":"string","description":"The formatted `additional_tax_total` with the order's currency symbol.\n"},"included_tax_total":{"type":"string","format":"float","description":"The total amount of additional tax applied to the order outside of the normal\nsales tax applied.\n"},"display_included_tax_total":{"type":"string","description":"The formatted `included_tax_total` with the order's currency symbol.\n"},"covered_by_store_credit":{"type":"boolean","description":"This is `true` if the user's available store credit is greater than\nor equal to the order's total.\n"},"total_applicable_store_credit":{"description":"How much store credit will be subtracted by this order's total.\n\nThis will be an integer 0 when there is not any store credit\navailable, otherwise, it will be a string float.\n","oneOf":[{"type":"string","format":"float"},{"type":"integer","enum":[0]}]},"display_total_applicable_store_credit":{"type":"string","description":"The `total_applicable_store_credit` formatted with the order's currency sign.\n"},"order_total_after_store_credit":{"type":"string","format":"float","description":"The order total after any and all `total_applicable_store_credit` is subtracted\nfrom the `total`.\n"},"display_order_total_after_store_credit":{"type":"string","description":"The `order_total_after_store_credit` formatted with the order's currecny sign.\n"},"display_total_available_store_credit":{"type":"string","description":"The total amount of store credit associated with the customer's account formatted\nwith the order's currency symbol.\n"},"display_store_credit_remaining_after_capture":{"type":"string","description":"The total amount of store credit after the payment has been captured formatted\nwith the order's currency symbol.\n"},"canceler_id":{"type":"integer","nullable":true,"description":"The ID of the user that canceled the order, if it has been canceled.\n"},"channel":{"type":"string"},"created_at":{"type":"string","format":"date-time"},"updated_at":{"type":"string","format":"date-time"},"completed_at":{"type":"string","format":"date-time","nullable":true},"payment_state":{"type":"string"},"shipment_state":{"type":"string","nullable":true},"hold_until":{"type":"string","format":"date-time"},"warehouse_sku":{"type":"string"},"special_instructions":{"type":"string","nullable":true},"state":{"type":"string"},"total_quantity":{"type":"integer","description":"The total number of items in the order."},"line_items":{"type":"array","items":{"$ref":"#/components/schemas/line-item"}},"metadata":{"$ref":"#/components/schemas/OrderMetadata"}}},"line-item":{"type":"object","title":"Line item","required":["adjustments"],"properties":{"id":{"type":"integer"},"adjustments":{"type":"array","items":{"$ref":"#/components/schemas/adjustment"}},"is_bundle":{"type":"boolean"},"subscription_type":{"type":"string"},"parts":{"type":"array","items":{"$ref":"#/components/schemas/part"}},"total":{"type":"string"},"display_amount":{"type":"string"},"price":{"type":"string","format":"float"},"single_display_amount":{"type":"string"},"quantity":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"},"variant_id":{"type":"integer"},"metadata":{"$ref":"#/components/schemas/metadata"},"cross_sold":{"type":"integer"},"dynamic_promotions":{"type":"array","items":{"$ref":"#/components/schemas/dynamic_promotion"}},"gift_cards":{"type":"array","items":{"$ref":"#/components/schemas/gift_card"}},"pre_paid_subscription":{"$ref":"#/components/schemas/PrepaidSubscriptionResponse"},"digital_purchases":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer"},"redeemed":{"type":"boolean"},"metadata":{"$ref":"#/components/schemas/metadata"}}}}}},"adjustment":{"type":"object","properties":{"adjustable_id":{"type":"integer"},"adjustable_type":{"type":"string"},"amount":{"type":"string"},"created_at":{"type":"string"},"display_amount":{"type":"string"},"eligible":{"type":"boolean"},"finalized":{"type":"boolean"},"id":{"type":"integer"},"label":{"type":"string"},"promotion_code_id":{"type":"integer"},"source_id":{"type":"integer"},"source_type":{"type":"string"},"updated_at":{"type":"string"},"promotion_code":{"properties":{"id":{"type":"integer"},"value":{"type":"string"}}}},"title":"Adjustment"},"part":{"type":"object","title":"Part within a parts array","properties":{"sku":{"type":"string","description":"SKU of the variant in the bundle"},"quantity":{"type":"integer","description":"The quantity of variant in this bundle"},"price":{"type":"number","format":"float","description":"The price of the variant in this bundle"}}},"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"},"dynamic_promotion":{"type":"object","required":["code"],"properties":{"code":{"type":"string"}}},"gift_card":{"type":"object","properties":{"id":{"type":"integer"},"filled":{"type":"boolean"},"amount":{"type":"string"},"recipient_email":{"type":"string"},"recipient_name":{"type":"string"},"gift_message":{"type":"string"},"send_email_at":{"type":"string"},"purchaser_name":{"type":"string"},"auto_redeem":{"type":"boolean"},"redemption_code":{"type":"string"}}},"PrepaidSubscriptionResponse":{"type":"object","required":["id","subscription_id","virtual_gift_card_id","actionable_date","auto_redeem","gift","recurring","amount","single_installment_price","state","quantity","installment_count","interval_length","interval_units","line_items","recipient","virtual_gift_card"],"properties":{"id":{"type":"integer"},"subscription_id":{"type":"integer","nullable":true},"virtual_gift_card_id":{"type":"integer","nullable":true},"actionable_date":{"type":"string","format":"date-time"},"auto_redeem":{"type":"boolean"},"gift":{"type":"boolean"},"recurring":{"type":"boolean"},"amount":{"type":"string","format":"float","description":"Total amount that the customer paid upfront for this subsciption.\n"},"single_installment_price":{"type":"string","format":"float","description":"The amount of money the customer paid for a single installment upfront.\n"},"state":{"type":"string","enum":["pending","active","completed"]},"quantity":{"type":"integer","minimum":1,"description":"The number of items that will be in the shipment.\n"},"installment_count":{"type":"number","description":"The number of times that the subsciption should be fulfilled.\n"},"fulfilled_installment_count":{"type":"number","description":"The number of times that the subsciption has been fulfilled within\na billing period.\n"},"interval_length":{"$ref":"#/components/schemas/IntervalLength"},"interval_units":{"$ref":"#/components/schemas/IntervalUnit"},"line_items":{"type":"array","items":{"type":"object","required":["quantity","variant"],"properties":{"quantity":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"}}}},"recipient":{"type":"object","required":["name","email","address"],"properties":{"name":{"type":"string"},"email":{"type":"string","format":"email"},"address":{"$ref":"#/components/schemas/address"}}},"virtual_gift_card":{"$ref":"#/components/schemas/gift_card"}}},"IntervalLength":{"type":"number","minimum":1,"description":"How many times a subscription should be fulfilled for a given\ninterval unit. Here are some examples.\n\n- Length = 1 and unit = `month` == once a month\n- Length = 2 and unit = `week` == every two weeks\n- Length = 1 and unit = `year` == once a year\n"},"IntervalUnit":{"type":"string","enum":["day","week","month","year"],"description":"The measurement of time applied to the interval unit of how often a\nsubscription is fulfilled.\n"},"address":{"type":"object","title":"Address","properties":{"id":{"type":"integer"},"name":{"type":"string"},"address1":{"type":"string"},"address2":{"type":"string","nullable":true},"city":{"type":"string"},"zipcode":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"alternative_phone":{"type":"string","nullable":true},"company":{"type":"string","nullable":true},"country_id":{"type":"integer"},"country_iso":{"type":"string"},"phone":{"type":"string","nullable":true},"state":{"$ref":"#/components/schemas/state"},"state_id":{"type":"integer"},"state_name":{"type":"string"},"state_text":{"type":"string"}}},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"},"OrderMetadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"}}}}
```

## The OrderSmall object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"OrderSmall":{"type":"object","title":"Order (small)","required":["id","number","token","user_id","email","currency","locale","total","display_total","item_total","display_item_total","payment_total","adjustment_total","ship_total","display_ship_total","tax_total","additional_tax_total","display_additional_tax_total","included_tax_total","display_included_tax_total","checkout_steps","created_at","updated_at","completed_at"],"properties":{"id":{"type":"integer"},"number":{"type":"string"},"token":{"type":"string","description":"This token can be used as a means of authentication for a subset\nof order operations in a guest checkout scenario. It should be passed\nas header named `X-Spree-Order-Token` on the request.\n"},"user_id":{"type":"integer","nullable":true,"description":"The ID of the user associated with this order. If the order is not in a completed\nstate and the customer is not logged in, this will be `null`.\n"},"email":{"type":"string","format":"email","nullable":true},"currency":{"type":"string","description":"The [ISO 4217 currency code](https://taxsummaries.pwc.com/glossary/currency-codes)\nfor the order.\n"},"locale":{"type":"string","nullable":true},"total":{"type":"string","format":"float","description":"This is the total amount of money that the customer paid/will pay.\nIt is the `item_total` + `shipment_total` + `adjustment_total`.\n"},"display_total":{"type":"string","description":"The formatted `total` with the currency's symbol.\n"},"item_total":{"type":"string","format":"float","description":"The total cost of the items in the cart. This does not include discounts,\nadjustments or shipping.\n"},"display_item_total":{"type":"string","format":"string","description":"The formatted `item_total` with the order's currency symbol.\n"},"payment_total":{"type":"string","format":"float","description":"TBD"},"adjustment_total":{"type":"string","format":"float","description":"The total amount discounted from the order.\n"},"ship_total":{"type":"string","format":"float","description":"The amount of money that the customer paid in shipping costs. For some of\nChord's payment methods, like Stripe, this amount in not known until after\nthe order is completed, as the address input is outside of Chord's systems.\n"},"display_ship_total":{"type":"string","description":"The formatted `ship_total` with the order's currency symbol.\n"},"tax_total":{"type":"string","format":"float","description":"The amount of money the the customer paid in taxes. For some of Chord's\npayment methods, like Stripe, this amount is not known until after the\norder is completed, as the address input is outside of Chord's systems.\n"},"display_tax_total":{"type":"string","description":"The `tax_total` formatted with the order's currency symbol.\n"},"additional_tax_total":{"type":"string","format":"float","description":"If the order requires VAT (Value Added Tax), this is the amount of tax the\ncustomer will pay.\n"},"display_additional_tax_total":{"type":"string","description":"The formatted `additional_tax_total` with the order's currency symbol.\n"},"included_tax_total":{"type":"string","format":"float","description":"The total amount of additional tax applied to the order outside of the normal\nsales tax applied.\n"},"display_included_tax_total":{"type":"string","description":"The formatted `included_tax_total` with the order's currency symbol.\n"},"covered_by_store_credit":{"type":"boolean","description":"This is `true` if the user's available store credit is greater than\nor equal to the order's total.\n"},"total_applicable_store_credit":{"description":"How much store credit will be subtracted by this order's total.\n\nThis will be an integer 0 when there is not any store credit\navailable, otherwise, it will be a string float.\n","oneOf":[{"type":"string","format":"float"},{"type":"integer","enum":[0]}]},"display_total_applicable_store_credit":{"type":"string","description":"The `total_applicable_store_credit` formatted with the order's currency sign.\n"},"order_total_after_store_credit":{"type":"string","format":"float","description":"The order total after any and all `total_applicable_store_credit` is subtracted\nfrom the `total`.\n"},"display_order_total_after_store_credit":{"type":"string","description":"The `order_total_after_store_credit` formatted with the order's currecny sign.\n"},"display_total_available_store_credit":{"type":"string","description":"The total amount of store credit associated with the customer's account formatted\nwith the order's currency symbol.\n"},"display_store_credit_remaining_after_capture":{"type":"string","description":"The total amount of store credit after the payment has been captured formatted\nwith the order's currency symbol.\n"},"checkout_steps":{"type":"array","items":{"type":"string"},"description":"The steps the customer must finish in order to complete the order.\n\n**This field is deprecated and will be removed at some point in the future\nas it doesn't mean anything in Chord's 1 step checkout based flows.**\n"},"canceler_id":{"type":"integer","nullable":true,"description":"The ID of the user that canceled the order, if it has been canceled.\n"},"channel":{"type":"string"},"created_at":{"type":"string","format":"date-time"},"updated_at":{"type":"string","format":"date-time"},"completed_at":{"type":"string","format":"date-time","nullable":true},"payment_state":{"type":"string"},"shipment_state":{"type":"string","nullable":true},"hold_until":{"type":"string","format":"date-time"},"warehouse_sku":{"type":"string"},"special_instructions":{"type":"string","nullable":true},"state":{"type":"string"},"total_quantity":{"type":"integer","description":"The total number of items in the order."},"line_items":{"type":"array","items":{"$ref":"#/components/schemas/line-item"}},"metadata":{"$ref":"#/components/schemas/OrderMetadata"},"cross_sell_details":{"$ref":"#/components/schemas/CrossSellDetails"}}},"line-item":{"type":"object","title":"Line item","required":["adjustments"],"properties":{"id":{"type":"integer"},"adjustments":{"type":"array","items":{"$ref":"#/components/schemas/adjustment"}},"is_bundle":{"type":"boolean"},"subscription_type":{"type":"string"},"parts":{"type":"array","items":{"$ref":"#/components/schemas/part"}},"total":{"type":"string"},"display_amount":{"type":"string"},"price":{"type":"string","format":"float"},"single_display_amount":{"type":"string"},"quantity":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"},"variant_id":{"type":"integer"},"metadata":{"$ref":"#/components/schemas/metadata"},"cross_sold":{"type":"integer"},"dynamic_promotions":{"type":"array","items":{"$ref":"#/components/schemas/dynamic_promotion"}},"gift_cards":{"type":"array","items":{"$ref":"#/components/schemas/gift_card"}},"pre_paid_subscription":{"$ref":"#/components/schemas/PrepaidSubscriptionResponse"},"digital_purchases":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer"},"redeemed":{"type":"boolean"},"metadata":{"$ref":"#/components/schemas/metadata"}}}}}},"adjustment":{"type":"object","properties":{"adjustable_id":{"type":"integer"},"adjustable_type":{"type":"string"},"amount":{"type":"string"},"created_at":{"type":"string"},"display_amount":{"type":"string"},"eligible":{"type":"boolean"},"finalized":{"type":"boolean"},"id":{"type":"integer"},"label":{"type":"string"},"promotion_code_id":{"type":"integer"},"source_id":{"type":"integer"},"source_type":{"type":"string"},"updated_at":{"type":"string"},"promotion_code":{"properties":{"id":{"type":"integer"},"value":{"type":"string"}}}},"title":"Adjustment"},"part":{"type":"object","title":"Part within a parts array","properties":{"sku":{"type":"string","description":"SKU of the variant in the bundle"},"quantity":{"type":"integer","description":"The quantity of variant in this bundle"},"price":{"type":"number","format":"float","description":"The price of the variant in this bundle"}}},"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"},"dynamic_promotion":{"type":"object","required":["code"],"properties":{"code":{"type":"string"}}},"gift_card":{"type":"object","properties":{"id":{"type":"integer"},"filled":{"type":"boolean"},"amount":{"type":"string"},"recipient_email":{"type":"string"},"recipient_name":{"type":"string"},"gift_message":{"type":"string"},"send_email_at":{"type":"string"},"purchaser_name":{"type":"string"},"auto_redeem":{"type":"boolean"},"redemption_code":{"type":"string"}}},"PrepaidSubscriptionResponse":{"type":"object","required":["id","subscription_id","virtual_gift_card_id","actionable_date","auto_redeem","gift","recurring","amount","single_installment_price","state","quantity","installment_count","interval_length","interval_units","line_items","recipient","virtual_gift_card"],"properties":{"id":{"type":"integer"},"subscription_id":{"type":"integer","nullable":true},"virtual_gift_card_id":{"type":"integer","nullable":true},"actionable_date":{"type":"string","format":"date-time"},"auto_redeem":{"type":"boolean"},"gift":{"type":"boolean"},"recurring":{"type":"boolean"},"amount":{"type":"string","format":"float","description":"Total amount that the customer paid upfront for this subsciption.\n"},"single_installment_price":{"type":"string","format":"float","description":"The amount of money the customer paid for a single installment upfront.\n"},"state":{"type":"string","enum":["pending","active","completed"]},"quantity":{"type":"integer","minimum":1,"description":"The number of items that will be in the shipment.\n"},"installment_count":{"type":"number","description":"The number of times that the subsciption should be fulfilled.\n"},"fulfilled_installment_count":{"type":"number","description":"The number of times that the subsciption has been fulfilled within\na billing period.\n"},"interval_length":{"$ref":"#/components/schemas/IntervalLength"},"interval_units":{"$ref":"#/components/schemas/IntervalUnit"},"line_items":{"type":"array","items":{"type":"object","required":["quantity","variant"],"properties":{"quantity":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"}}}},"recipient":{"type":"object","required":["name","email","address"],"properties":{"name":{"type":"string"},"email":{"type":"string","format":"email"},"address":{"$ref":"#/components/schemas/address"}}},"virtual_gift_card":{"$ref":"#/components/schemas/gift_card"}}},"IntervalLength":{"type":"number","minimum":1,"description":"How many times a subscription should be fulfilled for a given\ninterval unit. Here are some examples.\n\n- Length = 1 and unit = `month` == once a month\n- Length = 2 and unit = `week` == every two weeks\n- Length = 1 and unit = `year` == once a year\n"},"IntervalUnit":{"type":"string","enum":["day","week","month","year"],"description":"The measurement of time applied to the interval unit of how often a\nsubscription is fulfilled.\n"},"address":{"type":"object","title":"Address","properties":{"id":{"type":"integer"},"name":{"type":"string"},"address1":{"type":"string"},"address2":{"type":"string","nullable":true},"city":{"type":"string"},"zipcode":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"alternative_phone":{"type":"string","nullable":true},"company":{"type":"string","nullable":true},"country_id":{"type":"integer"},"country_iso":{"type":"string"},"phone":{"type":"string","nullable":true},"state":{"$ref":"#/components/schemas/state"},"state_id":{"type":"integer"},"state_name":{"type":"string"},"state_text":{"type":"string"}}},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"},"OrderMetadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"},"CrossSellDetails":{"type":"object","properties":{"cross_sellable":{"type":"boolean"},"cross_sell_duration_in_minutes":{"type":"integer"},"cross_sell_ends_at":{"type":"string","format":"date-time"}}}}}}
```

## The OrderBig object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"OrderBig":{"title":"Order (big)","allOf":[{"$ref":"#/components/schemas/OrderSmall"},{"type":"object","properties":{"checkout_session_id":{"type":"string","nullable":true},"store":{"type":"object","properties":{"id":{"type":"number"},"name":{"type":"string"},"code":{"type":"string"}}},"pre_paid_subscription_installment":{"type":"boolean"},"subscription_in_cart":{"type":"boolean"},"tag_list":{"type":"array","items":{"type":"string"}},"gift_note":{"$ref":"#/components/schemas/gift_note"}}}]},"OrderSmall":{"type":"object","title":"Order (small)","required":["id","number","token","user_id","email","currency","locale","total","display_total","item_total","display_item_total","payment_total","adjustment_total","ship_total","display_ship_total","tax_total","additional_tax_total","display_additional_tax_total","included_tax_total","display_included_tax_total","checkout_steps","created_at","updated_at","completed_at"],"properties":{"id":{"type":"integer"},"number":{"type":"string"},"token":{"type":"string","description":"This token can be used as a means of authentication for a subset\nof order operations in a guest checkout scenario. It should be passed\nas header named `X-Spree-Order-Token` on the request.\n"},"user_id":{"type":"integer","nullable":true,"description":"The ID of the user associated with this order. If the order is not in a completed\nstate and the customer is not logged in, this will be `null`.\n"},"email":{"type":"string","format":"email","nullable":true},"currency":{"type":"string","description":"The [ISO 4217 currency code](https://taxsummaries.pwc.com/glossary/currency-codes)\nfor the order.\n"},"locale":{"type":"string","nullable":true},"total":{"type":"string","format":"float","description":"This is the total amount of money that the customer paid/will pay.\nIt is the `item_total` + `shipment_total` + `adjustment_total`.\n"},"display_total":{"type":"string","description":"The formatted `total` with the currency's symbol.\n"},"item_total":{"type":"string","format":"float","description":"The total cost of the items in the cart. This does not include discounts,\nadjustments or shipping.\n"},"display_item_total":{"type":"string","format":"string","description":"The formatted `item_total` with the order's currency symbol.\n"},"payment_total":{"type":"string","format":"float","description":"TBD"},"adjustment_total":{"type":"string","format":"float","description":"The total amount discounted from the order.\n"},"ship_total":{"type":"string","format":"float","description":"The amount of money that the customer paid in shipping costs. For some of\nChord's payment methods, like Stripe, this amount in not known until after\nthe order is completed, as the address input is outside of Chord's systems.\n"},"display_ship_total":{"type":"string","description":"The formatted `ship_total` with the order's currency symbol.\n"},"tax_total":{"type":"string","format":"float","description":"The amount of money the the customer paid in taxes. For some of Chord's\npayment methods, like Stripe, this amount is not known until after the\norder is completed, as the address input is outside of Chord's systems.\n"},"display_tax_total":{"type":"string","description":"The `tax_total` formatted with the order's currency symbol.\n"},"additional_tax_total":{"type":"string","format":"float","description":"If the order requires VAT (Value Added Tax), this is the amount of tax the\ncustomer will pay.\n"},"display_additional_tax_total":{"type":"string","description":"The formatted `additional_tax_total` with the order's currency symbol.\n"},"included_tax_total":{"type":"string","format":"float","description":"The total amount of additional tax applied to the order outside of the normal\nsales tax applied.\n"},"display_included_tax_total":{"type":"string","description":"The formatted `included_tax_total` with the order's currency symbol.\n"},"covered_by_store_credit":{"type":"boolean","description":"This is `true` if the user's available store credit is greater than\nor equal to the order's total.\n"},"total_applicable_store_credit":{"description":"How much store credit will be subtracted by this order's total.\n\nThis will be an integer 0 when there is not any store credit\navailable, otherwise, it will be a string float.\n","oneOf":[{"type":"string","format":"float"},{"type":"integer","enum":[0]}]},"display_total_applicable_store_credit":{"type":"string","description":"The `total_applicable_store_credit` formatted with the order's currency sign.\n"},"order_total_after_store_credit":{"type":"string","format":"float","description":"The order total after any and all `total_applicable_store_credit` is subtracted\nfrom the `total`.\n"},"display_order_total_after_store_credit":{"type":"string","description":"The `order_total_after_store_credit` formatted with the order's currecny sign.\n"},"display_total_available_store_credit":{"type":"string","description":"The total amount of store credit associated with the customer's account formatted\nwith the order's currency symbol.\n"},"display_store_credit_remaining_after_capture":{"type":"string","description":"The total amount of store credit after the payment has been captured formatted\nwith the order's currency symbol.\n"},"checkout_steps":{"type":"array","items":{"type":"string"},"description":"The steps the customer must finish in order to complete the order.\n\n**This field is deprecated and will be removed at some point in the future\nas it doesn't mean anything in Chord's 1 step checkout based flows.**\n"},"canceler_id":{"type":"integer","nullable":true,"description":"The ID of the user that canceled the order, if it has been canceled.\n"},"channel":{"type":"string"},"created_at":{"type":"string","format":"date-time"},"updated_at":{"type":"string","format":"date-time"},"completed_at":{"type":"string","format":"date-time","nullable":true},"payment_state":{"type":"string"},"shipment_state":{"type":"string","nullable":true},"hold_until":{"type":"string","format":"date-time"},"warehouse_sku":{"type":"string"},"special_instructions":{"type":"string","nullable":true},"state":{"type":"string"},"total_quantity":{"type":"integer","description":"The total number of items in the order."},"line_items":{"type":"array","items":{"$ref":"#/components/schemas/line-item"}},"metadata":{"$ref":"#/components/schemas/OrderMetadata"},"cross_sell_details":{"$ref":"#/components/schemas/CrossSellDetails"}}},"line-item":{"type":"object","title":"Line item","required":["adjustments"],"properties":{"id":{"type":"integer"},"adjustments":{"type":"array","items":{"$ref":"#/components/schemas/adjustment"}},"is_bundle":{"type":"boolean"},"subscription_type":{"type":"string"},"parts":{"type":"array","items":{"$ref":"#/components/schemas/part"}},"total":{"type":"string"},"display_amount":{"type":"string"},"price":{"type":"string","format":"float"},"single_display_amount":{"type":"string"},"quantity":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"},"variant_id":{"type":"integer"},"metadata":{"$ref":"#/components/schemas/metadata"},"cross_sold":{"type":"integer"},"dynamic_promotions":{"type":"array","items":{"$ref":"#/components/schemas/dynamic_promotion"}},"gift_cards":{"type":"array","items":{"$ref":"#/components/schemas/gift_card"}},"pre_paid_subscription":{"$ref":"#/components/schemas/PrepaidSubscriptionResponse"},"digital_purchases":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer"},"redeemed":{"type":"boolean"},"metadata":{"$ref":"#/components/schemas/metadata"}}}}}},"adjustment":{"type":"object","properties":{"adjustable_id":{"type":"integer"},"adjustable_type":{"type":"string"},"amount":{"type":"string"},"created_at":{"type":"string"},"display_amount":{"type":"string"},"eligible":{"type":"boolean"},"finalized":{"type":"boolean"},"id":{"type":"integer"},"label":{"type":"string"},"promotion_code_id":{"type":"integer"},"source_id":{"type":"integer"},"source_type":{"type":"string"},"updated_at":{"type":"string"},"promotion_code":{"properties":{"id":{"type":"integer"},"value":{"type":"string"}}}},"title":"Adjustment"},"part":{"type":"object","title":"Part within a parts array","properties":{"sku":{"type":"string","description":"SKU of the variant in the bundle"},"quantity":{"type":"integer","description":"The quantity of variant in this bundle"},"price":{"type":"number","format":"float","description":"The price of the variant in this bundle"}}},"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"},"dynamic_promotion":{"type":"object","required":["code"],"properties":{"code":{"type":"string"}}},"gift_card":{"type":"object","properties":{"id":{"type":"integer"},"filled":{"type":"boolean"},"amount":{"type":"string"},"recipient_email":{"type":"string"},"recipient_name":{"type":"string"},"gift_message":{"type":"string"},"send_email_at":{"type":"string"},"purchaser_name":{"type":"string"},"auto_redeem":{"type":"boolean"},"redemption_code":{"type":"string"}}},"PrepaidSubscriptionResponse":{"type":"object","required":["id","subscription_id","virtual_gift_card_id","actionable_date","auto_redeem","gift","recurring","amount","single_installment_price","state","quantity","installment_count","interval_length","interval_units","line_items","recipient","virtual_gift_card"],"properties":{"id":{"type":"integer"},"subscription_id":{"type":"integer","nullable":true},"virtual_gift_card_id":{"type":"integer","nullable":true},"actionable_date":{"type":"string","format":"date-time"},"auto_redeem":{"type":"boolean"},"gift":{"type":"boolean"},"recurring":{"type":"boolean"},"amount":{"type":"string","format":"float","description":"Total amount that the customer paid upfront for this subsciption.\n"},"single_installment_price":{"type":"string","format":"float","description":"The amount of money the customer paid for a single installment upfront.\n"},"state":{"type":"string","enum":["pending","active","completed"]},"quantity":{"type":"integer","minimum":1,"description":"The number of items that will be in the shipment.\n"},"installment_count":{"type":"number","description":"The number of times that the subsciption should be fulfilled.\n"},"fulfilled_installment_count":{"type":"number","description":"The number of times that the subsciption has been fulfilled within\na billing period.\n"},"interval_length":{"$ref":"#/components/schemas/IntervalLength"},"interval_units":{"$ref":"#/components/schemas/IntervalUnit"},"line_items":{"type":"array","items":{"type":"object","required":["quantity","variant"],"properties":{"quantity":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"}}}},"recipient":{"type":"object","required":["name","email","address"],"properties":{"name":{"type":"string"},"email":{"type":"string","format":"email"},"address":{"$ref":"#/components/schemas/address"}}},"virtual_gift_card":{"$ref":"#/components/schemas/gift_card"}}},"IntervalLength":{"type":"number","minimum":1,"description":"How many times a subscription should be fulfilled for a given\ninterval unit. Here are some examples.\n\n- Length = 1 and unit = `month` == once a month\n- Length = 2 and unit = `week` == every two weeks\n- Length = 1 and unit = `year` == once a year\n"},"IntervalUnit":{"type":"string","enum":["day","week","month","year"],"description":"The measurement of time applied to the interval unit of how often a\nsubscription is fulfilled.\n"},"address":{"type":"object","title":"Address","properties":{"id":{"type":"integer"},"name":{"type":"string"},"address1":{"type":"string"},"address2":{"type":"string","nullable":true},"city":{"type":"string"},"zipcode":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"alternative_phone":{"type":"string","nullable":true},"company":{"type":"string","nullable":true},"country_id":{"type":"integer"},"country_iso":{"type":"string"},"phone":{"type":"string","nullable":true},"state":{"$ref":"#/components/schemas/state"},"state_id":{"type":"integer"},"state_name":{"type":"string"},"state_text":{"type":"string"}}},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"},"OrderMetadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"},"CrossSellDetails":{"type":"object","properties":{"cross_sellable":{"type":"boolean"},"cross_sell_duration_in_minutes":{"type":"integer"},"cross_sell_ends_at":{"type":"string","format":"date-time"}}},"gift_note":{"type":"object","title":"Gift Note","nullable":true,"description":"An optional note to attach to the order. For some fulfillment services,\nthis note might be printed and packaged with the order.\n","properties":{"from":{"type":"string"},"recipient":{"type":"string"},"note":{"type":"string"}}}}}}
```

## The CrossSellDetails object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"CrossSellDetails":{"type":"object","properties":{"cross_sellable":{"type":"boolean"},"cross_sell_duration_in_minutes":{"type":"integer"},"cross_sell_ends_at":{"type":"string","format":"date-time"}}}}}}
```

## The gift\_note object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"gift_note":{"type":"object","title":"Gift Note","nullable":true,"description":"An optional note to attach to the order. For some fulfillment services,\nthis note might be printed and packaged with the order.\n","properties":{"from":{"type":"string"},"recipient":{"type":"string"},"note":{"type":"string"}}}}}}
```

## The address object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"address":{"type":"object","title":"Address","properties":{"id":{"type":"integer"},"name":{"type":"string"},"address1":{"type":"string"},"address2":{"type":"string","nullable":true},"city":{"type":"string"},"zipcode":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"alternative_phone":{"type":"string","nullable":true},"company":{"type":"string","nullable":true},"country_id":{"type":"integer"},"country_iso":{"type":"string"},"phone":{"type":"string","nullable":true},"state":{"$ref":"#/components/schemas/state"},"state_id":{"type":"integer"},"state_name":{"type":"string"},"state_text":{"type":"string"}}},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"}}}}
```

## The country object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"}}}}
```

## The state object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"}}}}
```

## The adjustment object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"adjustment":{"type":"object","properties":{"adjustable_id":{"type":"integer"},"adjustable_type":{"type":"string"},"amount":{"type":"string"},"created_at":{"type":"string"},"display_amount":{"type":"string"},"eligible":{"type":"boolean"},"finalized":{"type":"boolean"},"id":{"type":"integer"},"label":{"type":"string"},"promotion_code_id":{"type":"integer"},"source_id":{"type":"integer"},"source_type":{"type":"string"},"updated_at":{"type":"string"},"promotion_code":{"properties":{"id":{"type":"integer"},"value":{"type":"string"}}}},"title":"Adjustment"}}}}
```

## The credit-card object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"credit-card":{"type":"object","title":"Credit card","properties":{"address":{},"cc_type":{"type":"string"},"id":{"type":"integer"},"last_digits":{"type":"string"},"month":{"type":"string"},"name":{"type":"string"},"year":{"type":"string"}}}}}}
```

## The line-item object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"line-item":{"type":"object","title":"Line item","required":["adjustments"],"properties":{"id":{"type":"integer"},"adjustments":{"type":"array","items":{"$ref":"#/components/schemas/adjustment"}},"is_bundle":{"type":"boolean"},"subscription_type":{"type":"string"},"parts":{"type":"array","items":{"$ref":"#/components/schemas/part"}},"total":{"type":"string"},"display_amount":{"type":"string"},"price":{"type":"string","format":"float"},"single_display_amount":{"type":"string"},"quantity":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"},"variant_id":{"type":"integer"},"metadata":{"$ref":"#/components/schemas/metadata"},"cross_sold":{"type":"integer"},"dynamic_promotions":{"type":"array","items":{"$ref":"#/components/schemas/dynamic_promotion"}},"gift_cards":{"type":"array","items":{"$ref":"#/components/schemas/gift_card"}},"pre_paid_subscription":{"$ref":"#/components/schemas/PrepaidSubscriptionResponse"},"digital_purchases":{"type":"array","items":{"type":"object","properties":{"id":{"type":"integer"},"redeemed":{"type":"boolean"},"metadata":{"$ref":"#/components/schemas/metadata"}}}}}},"adjustment":{"type":"object","properties":{"adjustable_id":{"type":"integer"},"adjustable_type":{"type":"string"},"amount":{"type":"string"},"created_at":{"type":"string"},"display_amount":{"type":"string"},"eligible":{"type":"boolean"},"finalized":{"type":"boolean"},"id":{"type":"integer"},"label":{"type":"string"},"promotion_code_id":{"type":"integer"},"source_id":{"type":"integer"},"source_type":{"type":"string"},"updated_at":{"type":"string"},"promotion_code":{"properties":{"id":{"type":"integer"},"value":{"type":"string"}}}},"title":"Adjustment"},"part":{"type":"object","title":"Part within a parts array","properties":{"sku":{"type":"string","description":"SKU of the variant in the bundle"},"quantity":{"type":"integer","description":"The quantity of variant in this bundle"},"price":{"type":"number","format":"float","description":"The price of the variant in this bundle"}}},"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"},"dynamic_promotion":{"type":"object","required":["code"],"properties":{"code":{"type":"string"}}},"gift_card":{"type":"object","properties":{"id":{"type":"integer"},"filled":{"type":"boolean"},"amount":{"type":"string"},"recipient_email":{"type":"string"},"recipient_name":{"type":"string"},"gift_message":{"type":"string"},"send_email_at":{"type":"string"},"purchaser_name":{"type":"string"},"auto_redeem":{"type":"boolean"},"redemption_code":{"type":"string"}}},"PrepaidSubscriptionResponse":{"type":"object","required":["id","subscription_id","virtual_gift_card_id","actionable_date","auto_redeem","gift","recurring","amount","single_installment_price","state","quantity","installment_count","interval_length","interval_units","line_items","recipient","virtual_gift_card"],"properties":{"id":{"type":"integer"},"subscription_id":{"type":"integer","nullable":true},"virtual_gift_card_id":{"type":"integer","nullable":true},"actionable_date":{"type":"string","format":"date-time"},"auto_redeem":{"type":"boolean"},"gift":{"type":"boolean"},"recurring":{"type":"boolean"},"amount":{"type":"string","format":"float","description":"Total amount that the customer paid upfront for this subsciption.\n"},"single_installment_price":{"type":"string","format":"float","description":"The amount of money the customer paid for a single installment upfront.\n"},"state":{"type":"string","enum":["pending","active","completed"]},"quantity":{"type":"integer","minimum":1,"description":"The number of items that will be in the shipment.\n"},"installment_count":{"type":"number","description":"The number of times that the subsciption should be fulfilled.\n"},"fulfilled_installment_count":{"type":"number","description":"The number of times that the subsciption has been fulfilled within\na billing period.\n"},"interval_length":{"$ref":"#/components/schemas/IntervalLength"},"interval_units":{"$ref":"#/components/schemas/IntervalUnit"},"line_items":{"type":"array","items":{"type":"object","required":["quantity","variant"],"properties":{"quantity":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"}}}},"recipient":{"type":"object","required":["name","email","address"],"properties":{"name":{"type":"string"},"email":{"type":"string","format":"email"},"address":{"$ref":"#/components/schemas/address"}}},"virtual_gift_card":{"$ref":"#/components/schemas/gift_card"}}},"IntervalLength":{"type":"number","minimum":1,"description":"How many times a subscription should be fulfilled for a given\ninterval unit. Here are some examples.\n\n- Length = 1 and unit = `month` == once a month\n- Length = 2 and unit = `week` == every two weeks\n- Length = 1 and unit = `year` == once a year\n"},"IntervalUnit":{"type":"string","enum":["day","week","month","year"],"description":"The measurement of time applied to the interval unit of how often a\nsubscription is fulfilled.\n"},"address":{"type":"object","title":"Address","properties":{"id":{"type":"integer"},"name":{"type":"string"},"address1":{"type":"string"},"address2":{"type":"string","nullable":true},"city":{"type":"string"},"zipcode":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"alternative_phone":{"type":"string","nullable":true},"company":{"type":"string","nullable":true},"country_id":{"type":"integer"},"country_iso":{"type":"string"},"phone":{"type":"string","nullable":true},"state":{"$ref":"#/components/schemas/state"},"state_id":{"type":"integer"},"state_name":{"type":"string"},"state_text":{"type":"string"}}},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"}}}}
```

## The payment-method object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"payment-method":{"type":"object","properties":{"id":{"type":"integer"},"method_type":{"type":"string"},"name":{"type":"string"},"partial_name":{"type":"string"}},"title":"Payment method"}}}}
```

## The payment object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"payment":{"type":"object","title":"Payment","properties":{"amount":{"type":"string"},"avs_response":{"type":"string"},"created_at":{"type":"string"},"display_amount":{"type":"string"},"id":{"type":"integer"},"payment_method":{"$ref":"#/components/schemas/payment-method"},"payment_method_id":{"type":"integer"},"source":{"$ref":"#/components/schemas/payment-source"},"source_id":{"type":"integer"},"source_type":{"type":"integer"},"state":{"type":"string"},"updated_at":{"type":"string"}}},"payment-method":{"type":"object","properties":{"id":{"type":"integer"},"method_type":{"type":"string"},"name":{"type":"string"},"partial_name":{"type":"string"}},"title":"Payment method"},"payment-source":{"type":"object","properties":{"cc_type":{"type":"string"},"gateway_customer_profile_id":{"type":"string"},"gateway_payment_profile_id":{"type":"string"},"id":{"type":"integer"},"last_digits":{"type":"string"},"month":{"type":"string"},"name":{"type":"string"},"year":{"type":"string"}},"title":"Payment source"}}}}
```

## The payment-source object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"payment-source":{"type":"object","properties":{"cc_type":{"type":"string"},"gateway_customer_profile_id":{"type":"string"},"gateway_payment_profile_id":{"type":"string"},"id":{"type":"integer"},"last_digits":{"type":"string"},"month":{"type":"string"},"name":{"type":"string"},"year":{"type":"string"}},"title":"Payment source"}}}}
```

## The shipment object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"shipment":{"type":"object","title":"Shipment","properties":{"adjustments":{"type":"array","items":{"$ref":"#/components/schemas/adjustment"}},"cost":{"type":"string"},"carrier":{"type":"string"},"external_tracking_url":{"type":"string"},"external_shipment_number":{"type":"string"},"fulfillment_service":{"type":"object","properties":{"name":{"type":"string"}}},"id":{"type":"integer"},"manifest":{"type":"array","items":{"$ref":"#/components/schemas/shipment-manifest"}},"number":{"type":"string"},"order_id":{"type":"string"},"selected_shipping_rate":{"$ref":"#/components/schemas/shipping-rate"},"shipped_at":{"type":"string"},"shipping_methods":{"type":"array","items":{"$ref":"#/components/schemas/shipping-method"}},"shipping_rates":{"type":"array","items":{"$ref":"#/components/schemas/shipping-rate"}},"state":{"type":"string"},"stock_location_name":{"type":"string"},"tracking":{"type":"string"},"tracking_url":{"type":"string"}}},"adjustment":{"type":"object","properties":{"adjustable_id":{"type":"integer"},"adjustable_type":{"type":"string"},"amount":{"type":"string"},"created_at":{"type":"string"},"display_amount":{"type":"string"},"eligible":{"type":"boolean"},"finalized":{"type":"boolean"},"id":{"type":"integer"},"label":{"type":"string"},"promotion_code_id":{"type":"integer"},"source_id":{"type":"integer"},"source_type":{"type":"string"},"updated_at":{"type":"string"},"promotion_code":{"properties":{"id":{"type":"integer"},"value":{"type":"string"}}}},"title":"Adjustment"},"shipment-manifest":{"type":"array","title":"Shipment manifest","items":{"type":"object","properties":{"quantity":{"type":"integer"},"states":{"type":"object","properties":{"on_hand":{"type":"integer"}}},"variant_id":{"type":"integer"},"sku":{"type":"string"}}}},"shipping-rate":{"type":"object","title":"Shipping rate","properties":{"cost":{"type":"string"},"display_cost":{"type":"string"},"id":{"type":"integer"},"name":{"type":"string"},"selected":{"type":"boolean"},"shipping_method_code":{"type":"string"},"shipping_method_id":{"type":"integer"}}},"shipping-method":{"type":"object","title":"Shipping method","properties":{"code":{"type":"string"},"id":{"type":"integer"},"name":{"type":"string"},"shipping_categories":{"type":"array","items":{"$ref":"#/components/schemas/shipping-category"}},"zones":{"type":"array","items":{"$ref":"#/components/schemas/zone"}}}},"shipping-category":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"}},"title":"Shipping category"},"zone":{"type":"object","properties":{"description":{"type":"string"},"id":{"type":"integer"},"name":{"type":"string"}},"title":"Zone"}}}}
```

## The shipping-rate object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"shipping-rate":{"type":"object","title":"Shipping rate","properties":{"cost":{"type":"string"},"display_cost":{"type":"string"},"id":{"type":"integer"},"name":{"type":"string"},"selected":{"type":"boolean"},"shipping_method_code":{"type":"string"},"shipping_method_id":{"type":"integer"}}}}}}
```

## The shipping-method object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"shipping-method":{"type":"object","title":"Shipping method","properties":{"code":{"type":"string"},"id":{"type":"integer"},"name":{"type":"string"},"shipping_categories":{"type":"array","items":{"$ref":"#/components/schemas/shipping-category"}},"zones":{"type":"array","items":{"$ref":"#/components/schemas/zone"}}}},"shipping-category":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"}},"title":"Shipping category"},"zone":{"type":"object","properties":{"description":{"type":"string"},"id":{"type":"integer"},"name":{"type":"string"}},"title":"Zone"}}}}
```

## The shipment-manifest object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"shipment-manifest":{"type":"array","title":"Shipment manifest","items":{"type":"object","properties":{"quantity":{"type":"integer"},"states":{"type":"object","properties":{"on_hand":{"type":"integer"}}},"variant_id":{"type":"integer"},"sku":{"type":"string"}}}}}}}
```

## The shipping-category object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"shipping-category":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"}},"title":"Shipping category"}}}}
```

## The zone object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"zone":{"type":"object","properties":{"description":{"type":"string"},"id":{"type":"integer"},"name":{"type":"string"}},"title":"Zone"}}}}
```

## The tracking\_preference object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"tracking_preference":{"type":"object","properties":{"destination":{"type":"string"},"preference":{"type":"boolean"}},"title":"Tracking Preference"}}}}
```

## The user object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"user":{"title":"User","type":"object","properties":{"id":{"type":"integer"},"email":{"type":"string","format":"email"},"created_at":{"type":"string","format":"date-time"},"updated_at":{"type":"string","format":"date-time"},"metadata":{"$ref":"#/components/schemas/metadata"},"notes":{"type":"string"},"name":{"type":"string","nullable":true},"phone":{"type":"string","nullable":true},"date_of_birth":{"type":"string","nullable":true,"format":"date"},"bill_address":{"$ref":"#/components/schemas/address"},"ship_address":{"$ref":"#/components/schemas/address"},"store_credit":{"type":"string"},"available_gift_cards":{"type":"array","items":{"$ref":"#/components/schemas/gift_card"}},"roles":{"type":"array","items":{"type":"string"}},"tracking_preferences":{"type":"array","items":{"$ref":"#/components/schemas/tracking_preference"}}}},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"},"address":{"type":"object","title":"Address","properties":{"id":{"type":"integer"},"name":{"type":"string"},"address1":{"type":"string"},"address2":{"type":"string","nullable":true},"city":{"type":"string"},"zipcode":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"alternative_phone":{"type":"string","nullable":true},"company":{"type":"string","nullable":true},"country_id":{"type":"integer"},"country_iso":{"type":"string"},"phone":{"type":"string","nullable":true},"state":{"$ref":"#/components/schemas/state"},"state_id":{"type":"integer"},"state_name":{"type":"string"},"state_text":{"type":"string"}}},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"},"gift_card":{"type":"object","properties":{"id":{"type":"integer"},"filled":{"type":"boolean"},"amount":{"type":"string"},"recipient_email":{"type":"string"},"recipient_name":{"type":"string"},"gift_message":{"type":"string"},"send_email_at":{"type":"string"},"purchaser_name":{"type":"string"},"auto_redeem":{"type":"boolean"},"redemption_code":{"type":"string"}}},"tracking_preference":{"type":"object","properties":{"destination":{"type":"string"},"preference":{"type":"boolean"}},"title":"Tracking Preference"}}}}
```

## The refund object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"refund":{"type":"object","title":"Refund","properties":{"id":{"type":"integer"},"created_at":{"type":"string"},"updated_at":{"type":"string"},"amount":{"type":"integer"},"payment_id":{"type":"integer"},"transaction_id":{"type":"string"},"reimbursement_id":{"type":"integer"},"refund_reason":{"type":"string"}}}}}}
```

## The return-item object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"return-item":{"type":"object","title":"Return Item","properties":{"id":{"type":"integer"},"inventory_unit_id":{"type":"integer"},"exchange_variant_id":{"type":"integer"},"created_at":{"type":"string"},"updated_at":{"type":"string"},"amount":{"type":"integer"},"included_tax_total":{"type":"integer"},"additional_tax_total":{"type":"integer"},"reception_status":{"type":"string"},"acceptance_status":{"type":"string"},"acceptance_status_errors":{"type":"string"},"exchange_inventory_unit_id":{"type":"integer"},"resellable":{"type":"boolean"},"customer_return":{"type":"string"},"reimbursement":{"type":"string"},"preferred_reimbursement_type":{"type":"string"},"override_reimbursement_type":{"type":"string"}}}}}}
```

## The return-authorization object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"return-authorization":{"type":"object","properties":{},"title":"Return authorization"}}}}
```

## The metadata object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"}}}}
```

## The OrderMetadata object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"OrderMetadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"}}}}
```

## The property object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"property":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"presentation":{"type":"string"}},"title":"Property"}}}}
```

## The inventory-unit object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"inventory-unit":{"type":"object","properties":{"id":{"type":"integer"},"shipment_id":{"type":"integer"},"state":{"type":"string"},"variant_id":{"type":"integer"}},"title":"Inventory unit"}}}}
```

## The stock-location object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"stock-location":{"type":"object","title":"Stock location","properties":{"active":{"type":"boolean"},"address1":{"type":"string"},"address2":{"type":"string"},"city":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"country_id":{"type":"integer"},"id":{"type":"integer"},"name":{"type":"string"},"phone":{"type":"string"},"state":{"$ref":"#/components/schemas/state"},"state_id":{"type":"integer"},"state_name":{"type":"string"},"zipcode":{"type":"string"}}},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"}}}}
```

## The stock-item object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"stock-item":{"type":"object","properties":{"backorderable":{"type":"boolean"},"count_on_hand":{"type":"integer"},"id":{"type":"integer"},"stock_location_id":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"},"variant_id":{"type":"integer"}},"title":"Stock item"},"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"}}}}
```

## The stock-movement object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"stock-movement":{"type":"object","title":"Stock movement","properties":{"id":{"type":"integer"},"quantity":{"type":"integer"},"stock_item":{"$ref":"#/components/schemas/stock-item"},"stock_item_id":{"type":"integer"}}},"stock-item":{"type":"object","properties":{"backorderable":{"type":"boolean"},"count_on_hand":{"type":"integer"},"id":{"type":"integer"},"stock_location_id":{"type":"integer"},"variant":{"$ref":"#/components/schemas/variant"},"variant_id":{"type":"integer"}},"title":"Stock item"},"variant":{"type":"object","title":"Variant","properties":{"cost_price":{"type":"string"},"depth":{"type":"string"},"description":{"type":"string"},"display_price":{"type":"string"},"height":{"type":"string"},"id":{"type":"integer"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"in_stock":{"type":"boolean"},"is_backorderable":{"type":"boolean"},"is_destroyed":{"type":"boolean"},"is_master":{"type":"boolean"},"name":{"type":"string"},"option_values":{"type":"array","items":{"$ref":"#/components/schemas/option-value"}},"options_text":{"type":"string"},"price":{"type":"string"},"sku":{"type":"string"},"slug":{"type":"string"},"total_on_hand":{"type":"integer"},"track_inventory":{"type":"boolean"},"weight":{"type":"string"},"width":{"type":"string"},"metadata":{"$ref":"#/components/schemas/metadata"}}},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"option-value":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"option_type_id":{"type":"integer"},"option_type_name":{"type":"string"},"option_type_presentation":{"type":"string"},"presentation":{"type":"string"}},"title":"Option value"},"metadata":{"type":"object","nullable":true,"additionalProperties":true,"properties":{},"title":"Metadata","description":"A key-value store of additional information. A key can be removed by\nsetting its value to null.\n"}}}}
```

## The store object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"store":{"type":"object","title":"Store","properties":{"available_locales":{"type":"array","items":{"type":"string"}},"code":{"type":"string"},"default":{"type":"boolean"},"default_currency":{"type":"string"},"id":{"type":"integer"},"mail_from_address":{"type":"string"},"meta_description":{"type":"string"},"meta_keywords":{"type":"string"},"name":{"type":"string"},"seo_title":{"type":"string"},"url":{"type":"string"}}}}}}
```

## The taxonomy object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"taxonomy":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"root":{"$ref":"#/components/schemas/taxon"}},"title":"Taxonomy"},"taxon":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"parent_id":{"type":"integer"},"permalink":{"type":"string"},"pretty_name":{"type":"string"},"taxonomy_id":{"type":"integer"},"taxons":{"type":"array","items":{"$ref":"#/components/schemas/taxon"}}},"title":"Taxon"}}}}
```

## The jstree object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"jstree":{"type":"array","items":{"type":"object","properties":{"attr":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"}}},"data":{"type":"string"},"state":{"type":"string"}}},"title":"jsTree"}}}}
```

## The promotion object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"promotion":{"type":"object","properties":{"advertise":{"type":"boolean"},"description":{"type":"string"},"expires_at":{"type":"string"},"id":{"type":"integer"},"match_policy":{"type":"string"},"name":{"type":"string"},"path":{"type":"string"},"starts_at":{"type":"string"},"type":{"type":"string"},"usage_limit":{"type":"integer"}},"title":"Promotion"}}}}
```

## The store-credit-event object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"store-credit-event":{"type":"object","title":"Store credit event","properties":{"display_action":{"type":"string"},"display_amount":{"type":"string"},"display_event_date":{"type":"string"},"display_remaining_amount":{"type":"string"},"display_user_total_amount":{"type":"string"},"order_number":{"type":"string"}}}}}}
```

## The coupon-code-handler object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"coupon-code-handler":{"type":"object","title":"Coupon code handler","properties":{"success":{"type":"string"},"error":{"type":"string"},"successful":{"type":"boolean"},"status_code":{"type":"string"}}}}}}
```

## The address-book object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"address-book":{"type":"array","title":"Address book","items":{"allOf":[{"$ref":"#/components/schemas/address"},{"type":"object","properties":{"default":{"type":"boolean"}}}]}},"address":{"type":"object","title":"Address","properties":{"id":{"type":"integer"},"name":{"type":"string"},"address1":{"type":"string"},"address2":{"type":"string","nullable":true},"city":{"type":"string"},"zipcode":{"type":"string"},"country":{"$ref":"#/components/schemas/country"},"alternative_phone":{"type":"string","nullable":true},"company":{"type":"string","nullable":true},"country_id":{"type":"integer"},"country_iso":{"type":"string"},"phone":{"type":"string","nullable":true},"state":{"$ref":"#/components/schemas/state"},"state_id":{"type":"integer"},"state_name":{"type":"string"},"state_text":{"type":"string"}}},"country":{"type":"object","properties":{"id":{"type":"integer"},"iso":{"type":"string"},"iso3":{"type":"string"},"iso_name":{"type":"string"},"name":{"type":"string"},"numcode":{"type":"integer"}},"title":"Country"},"state":{"type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"abbr":{"type":"string"},"country_id":{"type":"integer"}},"title":"State"}}}}
```

## The return-authorization-input object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"return-authorization-input":{"type":"object","title":"Return Authorization Input","properties":{"memo":{"type":"string"},"stock_location_id":{"type":"integer"},"return_reason_id":{"type":"integer"},"return_items_attributes":{"type":"array","items":{"type":"object","properties":{"inventory_unit_id":{"type":"integer"},"exchange_variant_id":{"type":"integer"},"return_reason_id":{"type":"integer"}}}}}}}}}
```

## The address-input object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"address-input":{"type":"object","title":"Address Input","required":["address1","city"],"properties":{"name":{"type":"string","description":"The full name of the user. You must provide this field OR one of OR both of `firstname` and `lastname` for\nthe payload to be valid.\n\nThis field will override `firstname` and `lastname` if both are provided.\n"},"firstname":{"type":"string","description":"The first name of the user. This field will be ignored if `name` is provided.\n"},"lastname":{"type":"string","description":"The last name of the user. This field will be ignored if `name` is provided.\n"},"address1":{"type":"string"},"address2":{"type":"string","nullable":true},"city":{"type":"string"},"state_name":{"type":"string","description":"Either the name of the state (\"New York\") or it's abbreviation (\"NY\").\n\nThis field (or `state_id`) is required if [`/api/countries/{country_id}/states`](#/paths/list-country-states)\nreturns `\"states_required\": true` in it's body.\n"},"state_id":{"type":"integer","description":"This ID can be found by calling [`/api/countries/{country_id}/states`](#/paths/list-country-states).\n\nThis field (or `state_name`) is required if the above endpoint returns `\"states_required\": true`.\n"},"country_id":{"type":"integer","description":"This ID can be found by calling [`/api/countries`](#/paths/list-countries). Either `country_id` OR `country_iso`\nmust be provided for this payload to be valid.\n"},"country_iso":{"type":"string","description":"The [ISO 3166-1 Alpha-2 country code](https://en.wikipedia.org/wiki/List_of_ISO_3166_country_codes) that the\nuser resides in. This list can be fetched from [`/api/countries`](#/paths/list-countries), where the key is\n`iso`.\n\nThis field OR `country_id` must be provided for this payload to be valid.\n"},"zipcode":{"type":"string","nullable":true,"description":"This field is required if the country requires a ZIP code, like the United States (`233`).\n"},"phone":{"type":"string","nullable":true},"alternative_phone":{"type":"string","nullable":true},"company":{"type":"string","nullable":true}}}}}}
```

## The LineItemIdentifier object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"LineItemIdentifier":{"type":"object","oneOf":[{"title":"sku","type":"object","required":["sku"],"properties":{"sku":{"type":"string"}}},{"title":"variant_id","type":"object","required":["variant_id"],"properties":{"variant_id":{"type":"integer"}}},{"title":"id","type":"object","description":"The existing line item ID of the item in the order","required":["id"],"properties":{"id":{"type":"integer"},"variant_id":{"type":"integer"},"sku":{"type":"string"}}}]}}}}
```

## The LineItemInput object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"LineItemInput":{"type":"object","title":"Line item input","allOf":[{"$ref":"#/components/schemas/LineItemIdentifier"},{"type":"object","properties":{"quantity":{"type":"integer","description":"The quantity of the item to be added to the cart. If `0` is passed or `quantity`\nis omitted from the payload, the item is removed from the cart.\n"},"options":{"type":"object","description":"This field can be used to pass custom line item attributes. When used, it will force a new price calculation, unless `price` is one of the options.","properties":{"parts":{"type":"array","items":{"$ref":"#/components/schemas/part"}}}},"subscription_line_items_attributes":{"type":"array","items":{"$ref":"#/components/schemas/subscription-line-item"}},"dynamic_promotions_attributes":{"type":"array","items":{"$ref":"#/components/schemas/dynamic_promotion"}},"digital_purchases_attributes":{"type":"array","items":{"type":"object","properties":{"metadata":{"type":"object","properties":{"auto_redeem":{"type":"boolean"}}}}}}}}]},"LineItemIdentifier":{"type":"object","oneOf":[{"title":"sku","type":"object","required":["sku"],"properties":{"sku":{"type":"string"}}},{"title":"variant_id","type":"object","required":["variant_id"],"properties":{"variant_id":{"type":"integer"}}},{"title":"id","type":"object","description":"The existing line item ID of the item in the order","required":["id"],"properties":{"id":{"type":"integer"},"variant_id":{"type":"integer"},"sku":{"type":"string"}}}]},"part":{"type":"object","title":"Part within a parts array","properties":{"sku":{"type":"string","description":"SKU of the variant in the bundle"},"quantity":{"type":"integer","description":"The quantity of variant in this bundle"},"price":{"type":"number","format":"float","description":"The price of the variant in this bundle"}}},"subscription-line-item":{"description":"","title":"Subscription line item","type":"object","properties":{"id":{"type":"number"},"_destroy":{"type":"boolean"},"quantity":{"type":"number"},"interval_length":{"$ref":"#/components/schemas/IntervalLength"},"interval_units":{"$ref":"#/components/schemas/IntervalUnit"},"end_date":{"type":"string"},"interval":{"type":"string","minLength":1},"sku":{"type":"string","minLength":1},"product_slug":{"type":"string","minLength":1},"subscription_type":{"type":"string"},"variant_id":{"type":"number"},"product_id":{"type":"number"},"name":{"type":"string"},"description":{"type":"string"},"price":{"type":"string"},"display_price":{"type":"string"},"options_text":{"type":"string"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"one_time":{"type":"boolean","description":"Indicates this is a one-time addition to the next installment"},"one_time_replace":{"type":"boolean","description":"Indicates this item replaces an existing subscription item for one installment"},"replaces_subscribable_id":{"type":"number","description":"When one_time_replace is true, the variant_id of the item being replaced"}}},"IntervalLength":{"type":"number","minimum":1,"description":"How many times a subscription should be fulfilled for a given\ninterval unit. Here are some examples.\n\n- Length = 1 and unit = `month` == once a month\n- Length = 2 and unit = `week` == every two weeks\n- Length = 1 and unit = `year` == once a year\n"},"IntervalUnit":{"type":"string","enum":["day","week","month","year"],"description":"The measurement of time applied to the interval unit of how often a\nsubscription is fulfilled.\n"},"image":{"type":"object","properties":{"alt":{"type":"string"},"attachment_content_type":{"type":"string"},"attachment_file_name":{"type":"string"},"attachment_height":{"type":"integer"},"attachment_updated_at":{"type":"string"},"attachment_width":{"type":"integer"},"id":{"type":"integer"},"large_url":{"type":"string"},"mini_url":{"type":"string"},"position":{"type":"integer"},"product_url":{"type":"string"},"small_url":{"type":"string"},"type":{"type":"string"},"viewable_id":{"type":"integer"},"viewable_type":{"type":"string"}},"title":"Image"},"dynamic_promotion":{"type":"object","required":["code"],"properties":{"code":{"type":"string"}}}}}}
```

## The AddLineItemInput object

```json
{"openapi":"3.0.0","info":{"title":"OMS API","version":"1.1"},"components":{"schemas":{"AddLineItemInput":{"allOf":[{"$ref":"#/components/schemas/LineItemInput"},{"type":"object","properties":{"options":{"type":"object","properties":{"prepaid_subscription":{"$ref":"#/components/schemas/PrepaidSubscriptionInput"},"parts":{"type":"array","items":{"$ref":"#/components/schemas/part"}}}}}}]},"LineItemInput":{"type":"object","title":"Line item input","allOf":[{"$ref":"#/components/schemas/LineItemIdentifier"},{"type":"object","properties":{"quantity":{"type":"integer","description":"The quantity of the item to be added to the cart. If `0` is passed or `quantity`\nis omitted from the payload, the item is removed from the cart.\n"},"options":{"type":"object","description":"This field can be used to pass custom line item attributes. When used, it will force a new price calculation, unless `price` is one of the options.","properties":{"parts":{"type":"array","items":{"$ref":"#/components/schemas/part"}}}},"subscription_line_items_attributes":{"type":"array","items":{"$ref":"#/components/schemas/subscription-line-item"}},"dynamic_promotions_attributes":{"type":"array","items":{"$ref":"#/components/schemas/dynamic_promotion"}},"digital_purchases_attributes":{"type":"array","items":{"type":"object","properties":{"metadata":{"type":"object","properties":{"auto_redeem":{"type":"boolean"}}}}}}}}]},"LineItemIdentifier":{"type":"object","oneOf":[{"title":"sku","type":"object","required":["sku"],"properties":{"sku":{"type":"string"}}},{"title":"variant_id","type":"object","required":["variant_id"],"properties":{"variant_id":{"type":"integer"}}},{"title":"id","type":"object","description":"The existing line item ID of the item in the order","required":["id"],"properties":{"id":{"type":"integer"},"variant_id":{"type":"integer"},"sku":{"type":"string"}}}]},"part":{"type":"object","title":"Part within a parts array","properties":{"sku":{"type":"string","description":"SKU of the variant in the bundle"},"quantity":{"type":"integer","description":"The quantity of variant in this bundle"},"price":{"type":"number","format":"float","description":"The price of the variant in this bundle"}}},"subscription-line-item":{"description":"","title":"Subscription line item","type":"object","properties":{"id":{"type":"number"},"_destroy":{"type":"boolean"},"quantity":{"type":"number"},"interval_length":{"$ref":"#/components/schemas/IntervalLength"},"interval_units":{"$ref":"#/components/schemas/IntervalUnit"},"end_date":{"type":"string"},"interval":{"type":"string","minLength":1},"sku":{"type":"string","minLength":1},"product_slug":{"type":"string","minLength":1},"subscription_type":{"type":"string"},"variant_id":{"type":"number"},"product_id":{"type":"number"},"name":{"type":"string"},"description":{"type":"string"},"price":{"type":"string"},"display_price":{"type":"string"},"options_text":{"type":"string"},"images":{"type":"array","items":{"$ref":"#/components/schemas/image"}},"one_time":{"type":"boolean","descript
[...]
